<template>
  <div id="map"></div>
</template>

<script lang="ts">
import { Component, Prop, Vue, Watch } from 'vue-property-decorator';
import { loadModules } from 'esri-loader';

@Component
export default class EsriMap extends Vue {
  @Prop() private zoom!: number;
  @Prop() private center!: number[];

  @Watch('zoom')
  onPropertyChanged(value: string, oldValue: string) {
    console.log('hi');
    if (this.view) {
      this.view.zoom = value;
    }
  }

  private view: any;

  async mounted() {
    const [ Map, MapView ] = await loadModules([
      'esri/Map',
      'esri/views/MapView'
    ], { css: true });
    const map = new Map({
      basemap: 'topo-vector'
    });
    this.view = new MapView({
      map,
      container: 'map',
      zoom: this.zoom,
      center: this.center,
      ui: { components: ['attribution'] }
    });
  }
}
</script>

<style scoped>
  #map {
    width: 100vw;
    height: 100vh;
  }
</style>
